SystemOrganization addCategory: #'Orca-Examples-ClassBrowser'!
SystemOrganization addCategory: #'Orca-Examples-Workspace'!
SystemOrganization addCategory: #'Orca-Examples-BallGame'!
SystemOrganization addCategory: #'Orca-Examples-System-Status'!
SystemOrganization addCategory: #'Orca-Examples-SynchronizedBallGame'!
SystemOrganization addCategory: #'Orca-Examples-TicTacToe'!
SystemOrganization addCategory: #'Orca-Examples-Chat'!

OrcaJqueryButton subclass: #OrcaSaveButton
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSaveButton class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 10:40:51.535'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.614'!
browser
	^ browser! !

!OrcaSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.624'!
browser: anObject
	browser := anObject! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'sec 3/23/2011 18:38'!
compileSource: source of: className 

	[ :cls :src | (Smalltalk classNamed: cls) compile: src ] onServer 
		value: className 
		value: source.! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 13:51:50.717'!
evaluateClassDefinition: aString

	[ :def | Compiler evaluate: def ] onServer value: aString.! !

!OrcaSaveButton methodsFor: 'initialization' stamp: 'hk 3/23/2011 14:04'!
initialize

	super initialize.
	self
		text: 'Save';
		onClickDo: [ self save ].! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 4/4/2011 15:12:53.677'!
isInputValidWith: source and: className

	| errorText |
	errorText := ''.
	"does anyone know how to do newline in JS?"
	source isEmpty ifTrue: [errorText := 'No source input.', [ String cr ] onServer value].
	className isEmpty ifTrue: [errorText := errorText, 'No class selected.'].
	errorText isEmpty ifFalse: [Js Global js alert: errorText].
	^ errorText isEmpty! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 14:20:13.047'!
save

	| source |
	source := self browser codeBox text.
	(self browser methodList currentSelection isEmpty)  
		ifTrue: [self evaluateClassDefinition: source]
		ifFalse: 
			[ |className|
			className := self browser classList selectedClassName.
			(self isInputValidWith: source and: className)
				ifTrue: [ self compileSource: source of: className]]
	! !

OrcaWidget subclass: #ChatMessageBox
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Chat'!

!ChatMessageBox class methodsFor: 'configuration' stamp: 'hk 5/4/2011 18:26'!
requiredClasses

	^ { ChatMessage . ChatMessageWidget }! !

!ChatMessageBox methodsFor: 'convenience' stamp: 'hk 5/4/2011 21:56'!
appendMessage: aMessage

	| messageWidget |
	messageWidget := ChatMessageWidget for: aMessage.
	self add: messageWidget.
	messageWidget slideIn.! !

!ChatMessageBox methodsFor: 'initialization' stamp: 'hk 5/4/2011 17:38'!
initialize

	super initialize.
	self cssClass: 'messageBox'.! !

OrcaWidget subclass: #ChatMessageWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Chat'!

!ChatMessageWidget class methodsFor: 'instance creation' stamp: 'hk 5/4/2011 17:41'!
for: aMessage

	^ self basicNew initializeWith: aMessage! !

!ChatMessageWidget class methodsFor: 'configuration' stamp: 'hk 5/4/2011 18:21'!
requiredClasses

	^ { OrcaParagraph }! !

!ChatMessageWidget class methodsFor: 'configuration' stamp: 'hk 5/4/2011 22:05'!
requiredScripts 

	^ { OrcaWidget latestJquery . OrcaWidget latestJqueryUi }! !

!ChatMessageWidget methodsFor: 'initialization' stamp: 'hk 5/4/2011 22:10'!
initializeWith: aMessage

	super initialize.
	self
		cssClass: 'message';
		add: (OrcaParagraph new text: aMessage time);
		add: (OrcaParagraph new text: aMessage author);
		add: (OrcaParagraph new text: aMessage text).! !

!ChatMessageWidget methodsFor: 'animation' stamp: 'hk 5/4/2011 22:04'!
slideIn

	self withDisposableId: [ :id |
		Js @ ('#', id) hide value.
		Js @ ('#', id) show value: 'slide'.
		].
		! !

OrcaWidget subclass: #OrcaChart
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaChart class methodsFor: 'configuration' stamp: 'hk 3/9/2011 10:38'!
defaultCssId

	^ self subclassResponsibility! !

!OrcaChart class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:33'!
requiredScripts
	
	^ { 'http://thejit.org/static/v20/Jit/jit.js' }! !

!OrcaChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart
	^ chart! !

!OrcaChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart: anObject
	chart := anObject! !

!OrcaChart methodsFor: 'initialization' stamp: 'hk 3/9/2011 11:01'!
initialize 

	super initialize.
	self
		cssId: self class defaultCssId;
		width: '100%';
		height: '400px'.! !

!OrcaChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 15:59'!
initializeWithData: json

	self chart loadJSON value: json.! !

!OrcaChart methodsFor: 'rendering' stamp: 'LT 4/4/2011 15:04:18.9'!
onShowTip: aTip for: anElement
	| label value |
		
	label := anElement name.
	value := anElement value.
	aTip innerHTML: label, ': ', value.
	aTip style backgroundColor: 'white'.! !

!OrcaChart methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:41'!
parameters

	^ self subclassResponsibility! !

OrcaChart subclass: #OrcaStackedChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

OrcaStackedChart subclass: #OrcaAreaChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaAreaChart class methodsFor: 'configuration' stamp: 'hk 3/7/2011 22:25'!
defaultCssId

	^ 'area'! !

!OrcaAreaChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:44'!
initializeWithData: json

	self chart: (Js jit AreaChart jsNew: self parameters).
	super initializeWithData: json.! !

!OrcaAreaChart methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:19'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByWeek ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

OrcaStackedChart subclass: #OrcaBarChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaBarChart class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:45'!
defaultCssId

	^ 'bar'! !

!OrcaBarChart methodsFor: 'initialization' stamp: 'sw 4/28/2011 13:39'!
initializeWithData: json

	self chart: (Js jit BarChart jsNew: self parameters).

	super initializeWithData: json.! !

!OrcaBarChart methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:19'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByWeekDay ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaBarChart methodsFor: 'configuration' stamp: 'sw 4/28/2011 12:56'!
parameters

	^ super parameters
		orientation: 'vertical';
		barsOffset: 20;
		yourself! !

OrcaBarChart subclass: #OrcaCommitsByHour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaCommitsByHour class methodsFor: 'configuration' stamp: 'SW 3/16/2011 16:18'!
defaultCssId

	^ 'commitsByHour'! !

!OrcaCommitsByHour methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:19'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByHour ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:21:19.284'!
label

	^  {#type -> 'HTML'.
		#size -> 13.
		#family -> 'Arial'.
		#color -> 'black' } asObject! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:05:32.517'!
parameters

	^ {#injectInto -> self class defaultCssId.
		#animate -> true.
		#Margin -> { #top -> 5 . #left -> 5 . #right -> 5 . #bottom -> 5 } asObject.
		#labelOffset -> 10.
		#showAggregates -> true.
		#showLabels -> true.
		#type -> 'stacked:gradient'.
		#Label -> self label.
		#Tips -> self tips.
		#filterOnClick -> true.
		#restoreOnRightClick -> true} asObject
		
! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:06:28.541'!
tips

	^ {#enable -> true.
	    #onShow -> [ :tip :element | self onShowTip: tip for: element ] } asObject! !

OrcaChart subclass: #OrcaTreeGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
classMethodsOf: aClass
	
	^ aClass class methodDict! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 11:47'!
defaultCssId 

	^ 'treegraph'! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
instanceMethodsOf: aClass

	^ aClass methodDict! !

!OrcaTreeGraph class methodsFor: 'json' stamp: 'sw 4/28/2011 13:36'!
jsonData
	"TODO this analysis does not make sense anymore"
	
	^ '(', (Json render: ( JsonObject new )), ')'
	"^ '(', (Json render: (self treeFor: OrcaBasicApp)), ')'"! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 12:32'!
jsonObjectFrom: aString

	^ JsonObject new
		at: #id put: aString;
		at: #name put: aString;
		yourself.
	! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
linesOfCodeForClass: aClass

	| sum |
	sum := 0.
	(self methodsOf: aClass) do: [ :each |
		sum := sum + (self linesOfCodeForMethod: each value) ].
	^ sum! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'ag 4/28/2011 11:13'!
linesOfCodeForClassNamed: aString

	| class |
	class := Smalltalk classNamed: aString.
	^ class
		ifNil: [ 0 ]
		ifNotNil: [ self linesOfCodeForClass: class]! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
linesOfCodeForMethod: aMethod

	^ aMethod decompileString lineCount! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
methodsOf: aClass

	| methods |
	methods := self instanceMethodsOf: aClass.
	methods addAll: (self classMethodsOf: aClass).
	^ methods! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'ag 4/28/2011 11:13'!
metricsForClassNamed: aString

	| class |
	class := Smalltalk classNamed: aString.
	^ OrderedCollection
		with: (self linesOfCodeForClass: class)
		with: (self numberOfMethodsOf: class)! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:13:56.332'!
node	

	^ {#overridable -> true.
		#type -> 'rectangle'.
		#color -> '#CDEB8B'.
		#width -> 200.
		#height -> 30.
		#lineWidth -> 5.
		#align -> 'center'.
		#CanvasStyles -> { #strokeStyle -> '#ffc' . #lineWidth -> 2 } asObject.
		} asObject! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
numberOfMethodsOf: aClass

	^ (self methodsOf: aClass) size
! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:22'!
requiredClasses
	
	^ { OrcaDialog }! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'ag 4/5/2011 17:44'!
transition 
	
	^ Js jit Trans Quart easeInOut! !

!OrcaTreeGraph class methodsFor: 'json' stamp: 'ag 4/28/2011 11:22'!
treeFor: aClass

	| jsonObject  collection |
	jsonObject := self jsonObjectFrom: aClass name.
	aClass subclasses ifNotEmpty:
		[ collection := OrderedCollection new.
		aClass subclassesDo: [ :each |
			collection add: (self treeFor: each) ].
		jsonObject at: #children put: (Array newFrom: collection) ].
	^ jsonObject.! !

!OrcaTreeGraph methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:45'!
initializeWithData: json

	self chart: (Js jit ST jsNew: self parameters).
	super initializeWithData: json.
	self chart compute value.
	self chart onClick value: self chart root.! !

!OrcaTreeGraph methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
metricsDialogNamed: aString with: aCollection

	| loc nom linesPerMethod |
	loc := aCollection first.
	nom := aCollection second.
	linesPerMethod := (loc / nom) roundTo: 0.1.
	
	^ OrcaDialog new
		title: aString;
		text: 'LoC: ', loc asString, ', NoM: ', nom asString, ', L/M: ', linesPerMethod asString;
		yourself! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 15:12:18.211'!
onBeforePlotNode: aNode

	| textLength width |
	textLength := Js Global number value: (aNode id length).
	width := textLength * 12.
	"perform since we can not use a $ in a selector directly yet"
	aNode data perform: #'$width:' with: width.
	aNode data perform: #'$height:' with: 25.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:19:39.391'!
onClick: aNode

	self chart onClick value: aNode id.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:07:49.179'!
onCreateLabel: aLabel for: aNode
	
	aLabel id: (aNode id).
	aLabel innerHTML: (aNode name).
	aLabel onclick: [ self onClick: aNode ].
	
	aLabel style
		cursor: 'pointer';
		font: '10px';
		padding: '5px';
		width: '190px';
		height: '20px';
		border: '1px solid #888'! !

!OrcaTreeGraph methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaTreeGraph jsonData ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'ag 4/5/2011 16:48'!
parameters

	^ {#orientation -> 'left'.
	      #injectInto -> self class defaultCssId.
		#duration -> 300.
		#transition -> self class transition.
		#levelDistance -> 50.
		#offsetX -> 0.
		#Navigation -> { #enable ->  true. #panning -> true } asObject.
		#Node -> self class node.
		#Edge -> { #type ->  'arrow' . #overridable -> true . #color -> 'lightblue' } asObject.	
		#onCreateLabel -> [ :label :mynode | self onCreateLabel: label for: mynode ] 
		} asObject! !

!OrcaTreeGraph methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
showDialogFor: aNode

	| className metrics |
	className := (Js Global string value: (aNode name)).
	metrics := [ :name | OrcaTreeGraph metricsForClassNamed: name ]
		onServer value: className.
	(self metricsDialogNamed: className with: metrics)
		addToWorld;
		initializeDialog.! !

OrcaWidget subclass: #OrcaClassBrowser
	instanceVariableNames: 'packageList protocolList classList methodList saveButton codeBox sideSelector spinner searchBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'hk 3/9/2011 12:38'!
defaultCssId

	^ 'browser'! !

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'sec 4/26/2011 18:56'!
isOrcaRootComponent
	^true! !

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'sec 4/26/2011 18:56'!
orcaTitle
	
	^ 'Class Browser'! !

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:02'!
requiredClasses
	
	^ { 
	"Browser-Widgets"
	OrcaSaveButton. OrcaCodeBox. OrcaSideSelector. OrcaSmartSearch. 
	"Browser-Panes"
	OrcaMethodPane. OrcaProtocolPane. OrcaClassPane. OrcaPackagePane.
	"Other Widgets"
	OrcaWindow. OrcaContainer. OrcaLoader}! !

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'sec 4/26/2011 18:55'!
uniquePath
	
	^ 'browser'! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addElements

	| lists classContainer all window |
	classContainer := (OrcaContainer vertical
		add: self classList;
		add: self sideSelector).

	lists := (OrcaContainer horizontal
		add: self packageList;
		add: classContainer;
		add: self protocolList;
		add: self methodList;
		yourself).
	all := OrcaContainer vertical
		add: self searchBox;
		add: lists;
		add: self codeBox;
		add: self saveButton;
		yourself.
	
	window := (OrcaWindow newTitled: 'Class Browser') add: all.
	
	self
		add: window;
		addToWorld.
		
	self spinner addToWorld.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
classList
	^ classList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'robi 1/17/2011 19:17'!
classList: anObject
	classList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 15:33:01.404'!
codeBox

	^ codeBox! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 4/6/2011 17:57'!
codeBox: anOrcaCodeBox

	codeBox := anOrcaCodeBox! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtons

	self saveButton: (OrcaSaveButton newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createPanes
	
	self codeBox: (OrcaCodeBox newOn: self).
	self methodList: (OrcaMethodPane newOn: self).
	self protocolList: (OrcaProtocolPane newOn: self).
	self classList: ((OrcaClassPane newOn: self) extent: 200 @ 260).
	self packageList: (OrcaPackagePane newOn: self).
	self sideSelector: (OrcaSideSelector newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createSearchBox

	self searchBox: (OrcaSmartSearch newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/28/2011 10:33'!
createSpinner
	
	self spinner: OrcaLoader new.! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:26'!
initialize

	super initialize.
	self
		cssId: self class defaultCssId;
		createSpinner;
		createSearchBox;
		createButtons;
		createPanes; 
		addElements.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList
	^ methodList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList: anObject
	methodList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.638'!
packageList
	^ packageList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.649'!
packageList: anObject
	packageList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList
	^ protocolList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList: anObject
	protocolList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.463'!
saveButton
	^ saveButton! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.474'!
saveButton: anObject
	saveButton := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.456'!
searchBox
	^ searchBox! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.464'!
searchBox: anObject
	searchBox := anObject! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 14:29:01.489'!
selectCategory: aString

	self protocolList select: aString.
	self methodList updateForClass: (self classList selectedClassName) in: aString.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 11:09:13.282'!
selectClass: aString

	self classList 
		select: aString;
		updateForClass.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 10:47:19.703'!
selectPackage: aString

	self packageList select: aString.
	self classList updateForPackage: aString.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:18:09.263'!
selectSelector: aString

	self methodList select: aString.
	self codeBox updateFor: aString of: self classList selectedClassName.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:03:07.737'!
selectSide: isClassSide

	isClassSide
		ifTrue: [self sideSelector switchToClassside]
		ifFalse: [self sideSelector switchToInstanceside]! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'LT 1/26/2011 16:54:08.361'!
showSide 

	self protocolList update.
	self codeBox displayClassDefinition.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector
	^ sideSelector! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector: anObject
	sideSelector := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner
	^ spinner! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner: anObject
	spinner := anObject! !

OrcaWidget subclass: #OrcaControlsTab
	instanceVariableNames: 'restartButton clearCacheButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaControlsTab class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:43'!
requiredClasses
	
	^ { OrcaButton. OrcaHeading. OrcaConfirm. OrcaContainer }! !

!OrcaControlsTab methodsFor: 'initialization' stamp: 'sw 4/28/2011 12:45'!
addElements

	| panel |
	panel := OrcaContainer vertical
		add: self restartButton;
		add: self clearCacheButton.
	self add: panel.! !

!OrcaControlsTab methodsFor: 'initialization' stamp: 'ag 4/6/2011 18:07'!
addTexts
	
	self add: (OrcaHeading new
		text: 'Here you can control the Orca Engine!! Please be aware of delays when forcing restart or clearing the cache!!';
			yourself).! !

!OrcaControlsTab methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton
	^ clearCacheButton! !

!OrcaControlsTab methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton: anObject
	clearCacheButton := anObject! !

!OrcaControlsTab methodsFor: 'initialization' stamp: 'ag 4/27/2011 10:05'!
createButtons
	
	self restartButton: (
		OrcaButton new
			text: 'Force restart of WebServer';
			onClickDo: [ :event | OrcaDispatcher hardRestart ] onServer).
	
	self	 clearCacheButton: (
		OrcaButton new
			text: 'Clear Cache of Translator';
			onClickDo: [ :event |
				OrcaConfirm new 
					block: [ OrcaClassesHandler clearCache ] onServer;
					confirm ];
			yourself).! !

!OrcaControlsTab methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:36'!
initialize 
	
	super initialize.
	self
		createButtons;
		addTexts;
		addElements.! !

!OrcaControlsTab methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton
	^ restartButton! !

!OrcaControlsTab methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton: anObject
	restartButton := anObject! !

OrcaWidget subclass: #OrcaMonticelloStatisticsTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaMonticelloStatisticsTab class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:15'!
requiredClasses
	
	^ { OrcaHeading. OrcaAreaChart. OrcaBarChart. OrcaCommitsByHour }! !

!OrcaMonticelloStatisticsTab methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addCommitDistribution

	| heading |
	
	heading := (OrcaHeading new text: 'Weekly commits per day').
	heading marginTop: 70.
	self add: heading .
	self add: OrcaBarChart new.
	

		
	! !

!OrcaMonticelloStatisticsTab methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addCommitsByHour

	| heading |
	
	heading := (OrcaHeading new text: 'Commits per hour').
	heading marginTop: 70.
	self add: heading .
	self add: OrcaCommitsByHour new.
	

		
	! !

!OrcaMonticelloStatisticsTab methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addOverviewOfCommits

	self add: (OrcaHeading new text: 'Overview of commits').
	self add: OrcaAreaChart new.
	
		
! !

!OrcaMonticelloStatisticsTab methodsFor: 'initialization' stamp: 'SW 3/16/2011 16:17'!
initialize

	super initialize.	
	
	self
		addOverviewOfCommits;
		addCommitDistribution;
		addCommitsByHour.! !

OrcaWidget subclass: #OrcaSystemStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaSystemStatus class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:38'!
isOrcaRootComponent
	
	^ true! !

!OrcaSystemStatus class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:38'!
orcaTitle
	
	^ 'System Status'! !

!OrcaSystemStatus class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:14'!
requiredClasses
	
	^ { OrcaTabHost. OrcaMonticelloStatisticsTab. OrcaSystemStatusTab. OrcaControlsTab }! !

!OrcaSystemStatus class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:38'!
uniquePath
	
	^ 'systat'! !

!OrcaSystemStatus methodsFor: 'initialization' stamp: 'ag 4/27/2011 13:39'!
addTabs

	| tabs |
	tabs := OrcaTabHost new
		add: (OrcaMonticelloStatisticsTab new) named: 'Monticello Statistics';
		add: (OrcaSystemStatusTab new) named: 'Class hierachy';
		add: (OrcaControlsTab new) named: 'System control'.
	self add: tabs.! !

!OrcaSystemStatus methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:40'!
initialize 
	
	super initialize.
	self addTabs.
! !

OrcaWidget subclass: #OrcaSystemStatusTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaSystemStatusTab class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:14'!
requiredClasses
	
	^ { OrcaTreeGraph. OrcaHeading }! !

!OrcaSystemStatusTab methodsFor: 'initialization' stamp: 'sw 4/28/2011 13:38'!
addGraph

	"self add: OrcaTreeGraph new."! !

!OrcaSystemStatusTab methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addTexts
	
	self add: (OrcaHeading new text: 'Application hierarchy').! !

!OrcaSystemStatusTab methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:45'!
initialize 
	
	super initialize.
	self
		addTexts;
		addGraph.! !

OrcaWidget subclass: #OrcaTicTacToe
	instanceVariableNames: 'mySymbol grid resultBanner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-TicTacToe'!

OrcaTicTacToe class
	instanceVariableNames: 'isActiveGame gameFields freeSymbols lastPlayer sessions'!

OrcaTicTacToe class
	instanceVariableNames: 'isActiveGame gameFields freeSymbols lastPlayer sessions'!

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 09:05'!
anybodyHasWon 

	^ (self whoHasWon = 'Nobody') not! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'hk 4/7/2011 16:55'!
emptyCellSymbol

	^ '&nbsp;'! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'sw 4/7/2011 15:43'!
fieldsPerRow
	
	^ 3
	! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'hk 4/8/2011 13:10'!
finishGame
	
	self sendResultBannerToClients.
	self isActiveGame: false.! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'hk 4/8/2011 13:08'!
freeSymbols

	((freeSymbols isNil) or: [freeSymbols isEmpty]) 
		ifTrue: [ freeSymbols := { 'X' . 'O'} asOrderedCollection ] .

 	^ freeSymbols! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'sw 4/8/2011 21:47'!
freeSymbols: anObject
	freeSymbols := anObject! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'sw 4/7/2011 15:42'!
gameFields
	^ gameFields! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'sw 4/7/2011 15:42'!
gameFields: anObject
	gameFields := anObject! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/7/2011 15:35'!
getSymbol 

	| symbol |
	symbol := self freeSymbols removeFirst.
	
	^ symbol .! !

!OrcaTicTacToe class methodsFor: 'class initialization' stamp: 'ag 4/27/2011 16:01'!
initialize
	"Cannot start new game when initializing this anymore... because: this code doesn't work - apps don't have global state, cannot access the session/clients."
	
	self newGame.! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'hk 4/8/2011 13:10'!
isActiveGame
	^ isActiveGame! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'hk 4/8/2011 13:10'!
isActiveGame: anObject
	isActiveGame := anObject! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:57'!
isOrcaRootComponent
	
	^ true! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 21:48'!
isValidMoveOf: anSymbol at: anIndex
	
	^ ((self gameFields at: anIndex) = OrcaTicTacToe emptyCellSymbol ) 
			and: [ self isActiveGame ]
			and: [ (self lastPlayer = anSymbol) not ]! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'sw 4/8/2011 21:47'!
lastPlayer
	^ lastPlayer! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'sw 4/8/2011 21:47'!
lastPlayer: anObject
	lastPlayer := anObject! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 21:47'!
newGame

	self gameFields: OrderedCollection new.	
	self isActiveGame: true.
	(1 to: self fieldsPerRow squared ) do: 
		[ :i | self gameFields add: self emptyCellSymbol ].
	
	self sendGameFieldsToClients.
	self lastPlayer: ' '.
	^ true
	! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 08:51'!
noFreeFieldsLeft 

	| res |
	res := true.
	
	self gameFields do: [ :each |
		(each = self emptyCellSymbol ) 
			ifTrue: [
				^ res := false
				] 
		].
	^ res! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/27/2011 15:29'!
orcaSessionClass
	
	^ TicTacToeSession! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:57'!
orcaTitle 

	^ 'Tic-Tac-Toe'! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 21:49'!
putMySymbol: anSymbol at: anIndex 

	(self isValidMoveOf: anSymbol at: anIndex) ifTrue: [
		self gameFields at: anIndex put: anSymbol.
		self sendGameFieldsToClients.	
		self lastPlayer: anSymbol.
		(self anybodyHasWon or: [ self noFreeFieldsLeft ]) ifTrue: [
			self finishGame.
			].
	].
	
	^ true! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:27'!
requiredClasses  

	^ { OrcaHeading. OrcaText. OrcaButton. OrcaTicTacToeGrid }! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/27/2011 14:02'!
requiredStyles

	^ { 'tictactoe.css' }! !

!OrcaTicTacToe class methodsFor: 'communication' stamp: 'ag 4/27/2011 15:39'!
sendGameFieldsToClients

	self sendToAll: 'app refreshGrid'.! !

!OrcaTicTacToe class methodsFor: 'communication' stamp: 'ag 4/27/2011 15:39'!
sendResultBannerToClients

	self sendToAll: 'app refreshBanner'.! !

!OrcaTicTacToe class methodsFor: 'communication' stamp: 'sw 4/28/2011 14:04'!
sendToAll: code

	[ self sessions do: [ :each | each sendCode: code] ]
		fork! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'sw 4/28/2011 14:00'!
serverStartupClass
	
	^ self! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'ag 4/27/2011 15:31'!
sessions
	
	sessions ifNil: [ sessions := OrderedCollection new ].

	^ sessions! !

!OrcaTicTacToe class methodsFor: 'accessing' stamp: 'ag 4/27/2011 15:30'!
sessions: anObject
	sessions := anObject! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'ag 4/27/2011 15:31'!
startOnServer: aSession
	
	self sessions add: aSession.! !

!OrcaTicTacToe class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:57'!
uniquePath 

	^ 'xxo'! !

!OrcaTicTacToe class methodsFor: 'gameplay' stamp: 'sw 4/8/2011 09:12'!
whoHasWon 
	
	| ml mm mr om um ol or ul ur |
	ol := self gameFields at:1.
	om := self gameFields at:2.
	or := self gameFields at:3.
	
	ml := self gameFields at:4.
	mm := self gameFields at:5.
	mr := self gameFields at:6.
	
	ul := self gameFields at:7.
	um := self gameFields at:8.
	ur := self gameFields at:9.
	
	"horizontal lines "
	((om = ol) and: [ om = or ] and: [ (om = self emptyCellSymbol) not]) ifTrue: [
		^ om
		].
	((mm = ml) and: [ mm = mr ] and: [ (mm = self emptyCellSymbol) not]) ifTrue: [
		^ mm
		].
	
	((um = ul) and: [ um = ur ] and: [ (um = self emptyCellSymbol) not]) ifTrue: [
		^ um
		].
	
	"vertical lines "
	((ol = ml) and: [ ml = ul ] and: [ (ml = self emptyCellSymbol) not]) ifTrue: [
		^ ml
		].
	((om = mm) and: [ mm = um ]and: [ (mm = self emptyCellSymbol) not]) ifTrue: [
		^ mm
		].
	((or = mr) and: [ mr = ur ]and: [ (mr = self emptyCellSymbol) not]) ifTrue: [
		^ mr
		].
	
	"diagonal lines "
	((ol = mm) and: [ mm = ur ] and: [ (mm = self emptyCellSymbol) not]) ifTrue: [
		^ mm
		].
	((or = mm) and: [ mm = ul ] and: [ (mm = self emptyCellSymbol) not]) ifTrue: [
		^ mm
		].
	
	
	
	^ 'Nobody'! !

!OrcaTicTacToe methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:26'!
addElements

	self
		add: (OrcaHeading new text: self orcaTitle);
		add: (OrcaText new text: 'Your symbol is: ', self mySymbol);
		add: (OrcaButton new text: 'New Game'; onClickDo: [ self newGame]);
		add: self grid;
		add: self resultBanner.! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/7/2011 16:04'!
grid
	^ grid! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/7/2011 16:04'!
grid: anObject
	grid := anObject! !

!OrcaTicTacToe methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:27'!
initialize

	super initialize.
	self mySymbol: ([ OrcaTicTacToe getSymbol ] onServer value).
	self grid: OrcaTicTacToeGrid new.
	self grid symbol: self mySymbol.
	self resultBanner: (OrcaHeading new).
	self addElements.
	self refreshGrid.! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/7/2011 15:27'!
mySymbol
	^ mySymbol! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/7/2011 15:27'!
mySymbol: anObject
	mySymbol := anObject! !

!OrcaTicTacToe methodsFor: 'initialization' stamp: 'hk 4/8/2011 12:15'!
newGame

	[ OrcaTicTacToe newGame ] onServer value.

! !

!OrcaTicTacToe methodsFor: 'rendering' stamp: 'hk 4/8/2011 12:59'!
refreshBanner

	| winner |
	winner := [ OrcaTicTacToe whoHasWon ] onServer value.
	
	self resultBanner text: winner , ' has won!!'.! !

!OrcaTicTacToe methodsFor: 'rendering' stamp: 'sw 4/7/2011 17:43'!
refreshGrid

	| status |
	status := [ OrcaTicTacToe gameFields ] onServer value.
	
	self grid fillWith: status! !

!OrcaTicTacToe methodsFor: 'rendering' stamp: 'hk 4/8/2011 13:00'!
reset

	self resultBanner clear.! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/8/2011 08:33'!
resultBanner
	^ resultBanner! !

!OrcaTicTacToe methodsFor: 'accessing' stamp: 'sw 4/8/2011 08:33'!
resultBanner: anObject
	resultBanner := anObject! !

OrcaWidget subclass: #OrcaWorkspace
	instanceVariableNames: 'smalltalkCodeBox javascriptCodeBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Workspace'!

OrcaWorkspace subclass: #OrcaCodeBox
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaCodeBox class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 17:04:37.953'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaCodeBox class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:03'!
requiredClasses
	
	^ { OrcaContainer }! !

!OrcaCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.802'!
browser
	^ browser! !

!OrcaCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.812'!
browser: anObject
	browser := anObject! !

!OrcaCodeBox methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtonsForInput: aNode

	^ OrcaContainer horizontal! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'LT 2/23/2011 13:55:43.357'!
displayClassDefinition

	| definition className |
	self browser saveButton enable.
	className := self browser classList selectedClassName.
	className isEmpty
		ifFalse: 
			[definition := [ :cls | (Smalltalk classNamed: cls) definition ] onServer value: className.
			self text: definition]! !

!OrcaCodeBox methodsFor: 'initialization' stamp: 'hk 1/26/2011 17:02'!
initialize 

	super initialize.
	self
		extent: 800 @ 300;
		yourself.! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode | | assoc |
		[ assoc := OrcaPrettyPrinter convertMethod: smalltalkCode. assoc key, ' = ', assoc value ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'LT 3/1/2011 16:17:26.873'!
updateFor: aMethodname of: aClassname

	self browser spinner show.
	self clear.
	self browser saveButton enable.
	self text: (
		[ :methodName :classname |
		((Smalltalk classNamed: classname) methodDict at: methodName asSymbol) getSource asString ]
			onServer
				value: aMethodname
				value: aClassname).
	self browser spinner hide.! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'hk 4/4/2011 14:40'!
emptyBoxString

	^ 'nothing yet'! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'robi 1/26/2011 13:12'!
htmlElementType
	
	^ 'div'! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:05'!
isOrcaRootComponent
	
	^ true! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:29'!
orcaTitle
	
	^ 'Workspace'! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:05'!
requiredClasses
	
	^ { OrcaContainer. OrcaButton. OrcaTextArea. OrcaTabbyTextArea }! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'ag 4/27/2011 13:29'!
uniquePath

	^ 'workspace'! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:41'!
addElements
	
	self add: 
		(OrcaContainer vertical
			add: (OrcaContainer horizontal
				add: self smalltalkCodeBox;
				add: self javascriptCodeBox);
			add: (self createButtonsForInput: self smalltalkCodeBox);
			yourself).! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/5/2011 14:54'!
bindInput: anInputTextWidget toOutput: anOutputTextWidget
	
	anInputTextWidget node onkeyup: [ :event | | shouldUpdate |
		shouldUpdate := #(32 13 9 46 190) includes: event keyCode.
		shouldUpdate ifTrue:
			[ self
				updateOutput: anOutputTextWidget
				fromInput: anInputTextWidget ]].! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'sec 2/28/2011 17:31'!
clear

	self smalltalkCodeBox clear.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/28/2011 11:40'!
createButtonsForInput: anInputWidget
	
	^ OrcaContainer horizontal addAll: {
		OrcaButton doing: [ self printContentOf: anInputWidget ] withText: 'Print'.
		OrcaButton doing: [ self doIt: anInputWidget text ] withText: 'Do it' }! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createJsCodeBox

	^ OrcaTextArea new
		extent: 600 @ 400;
		beReadOnly;
		yourself.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createStCodeBox

	^ OrcaTabbyTextArea new
		extent: 600 @ 400;
		yourself.! !

!OrcaWorkspace methodsFor: 'logic' stamp: 'hk 3/31/2011 14:29'!
doIt: aSmalltalkSnippet

	^ Js Global eval value: (self translate: aSmalltalkSnippet).! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'hk 3/31/2011 14:30'!
extent

	^ self smalltalkCodeBox extent + self javascriptCodeBox extent! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'hk 4/4/2011 10:26'!
extent: newExtent

	self smalltalkCodeBox extent: (newExtent x * 0.5 @ newExtent y).
	self javascriptCodeBox extent: (newExtent x * 0.5 @ newExtent y).! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:50'!
initialize

	super initialize.
	self smalltalkCodeBox: self createStCodeBox.
	self javascriptCodeBox: self createJsCodeBox.
	self
		addElements;
		bindInput: self smalltalkCodeBox
		toOutput: self javascriptCodeBox.! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox
	^ javascriptCodeBox! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox: anObject
	javascriptCodeBox := anObject! !

!OrcaWorkspace methodsFor: 'logic' stamp: 'hk 4/4/2011 10:52'!
printContentOf: anInputWidget

	| stCode |
	stCode := anInputWidget text..
	anInputWidget text: stCode, ' ', (self translate: stCode).! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox
	^ smalltalkCodeBox! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox: anObject
	smalltalkCodeBox := anObject! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 3/31/2011 14:31'!
text

	^ self smalltalkCodeBox text! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'sec 2/22/2011 12:36'!
text: aString

	self smalltalkCodeBox text: aString.
	self updateOutput: self javascriptCodeBox fromInput: self smalltalkCodeBox.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode |
		[ OrcaPrettyCodeFactory codeFor: smalltalkCode ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 14:40'!
updateOutput: aJavascriptCodeBox fromInput: aSmalltalkCodeBox

	| jsCode stCode |
	stCode := aSmalltalkCodeBox text.
	jsCode := aJavascriptCodeBox text
		ifEmpty: self class emptyBoxString.
	jsCode := (self translate: stCode)
		ifEmpty: self class emptyBoxString.
	aJavascriptCodeBox text: jsCode.! !

OrcaForm subclass: #ChatApplication
	instanceVariableNames: 'messageBox nameInput textInput sendButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Chat'!

!ChatApplication class methodsFor: 'configuration' stamp: 'sw 5/4/2011 15:14'!
isOrcaRootComponent 

	 ^ true
	! !

!ChatApplication class methodsFor: 'configuration' stamp: 'sw 5/4/2011 15:22'!
orcaSessionClass 

	^ ChatSession! !

!ChatApplication class methodsFor: 'configuration' stamp: 'hk 5/4/2011 17:01'!
orcaTitle

	^ 'Chat'! !

!ChatApplication class methodsFor: 'configuration' stamp: 'hk 5/4/2011 22:02'!
requiredClasses 

	 ^ { OrcaHeading . OrcaInput . ChatMessageBox . OrcaTextArea . OrcaButton . ChatMessage }! !

!ChatApplication class methodsFor: 'configuration' stamp: 'hk 5/4/2011 18:17'!
requiredStyles

	^ { 'chat.css' }! !

!ChatApplication class methodsFor: 'messaging' stamp: 'hk 5/4/2011 17:35'!
spread: aMessage

	" this will be obsolete when remote objects are finished"

	ChatSession allInstancesDo: [ :each | | jsCode |
		jsCode := 'st.app.receiveMessage_((function() {', aMessage serializeToJavaScript, '})());'.
		each channel send: jsCode ].! !

!ChatApplication class methodsFor: 'messaging' stamp: 'hk 5/4/2011 18:27'!
spread: aText from: anAuthor

	| message |
	message := ChatMessage new
		author: anAuthor;
		text: aText.
	self spread: message.! !

!ChatApplication class methodsFor: 'configuration' stamp: 'hk 5/4/2011 16:35'!
start
	
	^ self new ! !

!ChatApplication class methodsFor: 'configuration' stamp: 'sw 5/4/2011 15:16'!
uniquePath 

	^ 'chat'! !

!ChatApplication methodsFor: 'initialization' stamp: 'hk 5/4/2011 18:45'!
addWidgets

	self
		add: (OrcaHeading new text: 'Chat');
		add: self nameInput;
		add: self messageBox;
		add: self textInput;
		add: self sendButton.! !

!ChatApplication methodsFor: 'initialization' stamp: 'hk 5/4/2011 16:48'!
initialize 

	super initialize.
	self
		initializeWidgets;
		addWidgets;
		addToWorld.! !

!ChatApplication methodsFor: 'initialization' stamp: 'hk 5/4/2011 22:03'!
initializeButton

	self sendButton: (OrcaButton new 
		text: 'Send';
		onClickDo: [ self verifyMessage ]).! !

!ChatApplication methodsFor: 'initialization' stamp: 'hk 5/4/2011 20:44'!
initializeWidgets

	self
		nameInput: (OrcaInput new beRequired);
		messageBox: ChatMessageBox new;
		textInput: OrcaTextArea new;
		initializeButton.! !

!ChatApplication methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:19'!
messageBox
	^ messageBox! !

!ChatApplication methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:19'!
messageBox: anObject
	messageBox := anObject! !

!ChatApplication methodsFor: 'accessing' stamp: 'hk 5/4/2011 18:43'!
nameInput
	^ nameInput! !

!ChatApplication methodsFor: 'accessing' stamp: 'hk 5/4/2011 18:44'!
nameInput: anObject
	nameInput := anObject! !

!ChatApplication methodsFor: 'messaging' stamp: 'hk 5/4/2011 18:20'!
receiveMessage: aMessage

	self messageBox appendMessage: aMessage.! !

!ChatApplication methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:19'!
sendButton
	^ sendButton! !

!ChatApplication methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:19'!
sendButton: anObject
	sendButton := anObject! !

!ChatApplication methodsFor: 'messaging' stamp: 'hk 5/4/2011 18:45'!
sendMessage

	[ :aMessage :anAuthor |
		ChatApplication
			spread: aMessage
			from: anAuthor. nil ] onServer
				value: self textInput text
				value: self nameInput text! !

!ChatApplication methodsFor: 'accessing' stamp: 'hk 5/4/2011 18:45'!
textInput
	^ textInput! !

!ChatApplication methodsFor: 'accessing' stamp: 'hk 5/4/2011 18:45'!
textInput: anObject
	textInput := anObject! !

!ChatApplication methodsFor: 'messaging' stamp: 'hk 5/4/2011 18:45'!
verifyMessage

	(self textInput isBlank or: [ self nameInput isBlank ])
		ifFalse: [ 
			self sendMessage.
			self textInput clear
			].! !

OrcaSession subclass: #ChatSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Chat'!

OrcaSession subclass: #TicTacToeSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-TicTacToe'!

!TicTacToeSession methodsFor: 'cleanup' stamp: 'ag 4/27/2011 15:33'!
cleanup
	
	super cleanup.
	OrcaTicTacToe sessions remove: self ifAbsent: [].! !

OrcaCircle subclass: #OrcaBall
	instanceVariableNames: 'speed direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OrcaBall class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:07'!
requiredClasses
	
	^ { Point }! !

!OrcaBall methodsFor: 'logic' stamp: 'ag 4/5/2011 10:28'!
bounceIfNeeded
	
	(self position x > self canvas width or: 
	[self position x < 0])
		ifTrue: [
			self direction: 
				(self direction x * -1) @ self direction y ].
	
	(self position y > self canvas height or: 
	[self position y < 0])
		ifTrue: [
			self direction: 
				self direction x @ (self direction y * -1) ].! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction
	^ direction! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction: anObject
	direction := anObject! !

!OrcaBall methodsFor: 'initialize-release' stamp: 'ag 1/24/2011 17:12'!
initialize
	
	super initialize.
	self speed: 2.
	self direction: 1@1.! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
speed
	^ speed! !

!OrcaBall methodsFor: 'accessing' stamp: 'lw 2/2/2011 23:31'!
speed: anObject

	speed := anObject
! !

!OrcaBall methodsFor: 'logic' stamp: 'ag 3/1/2011 11:18'!
step
	
	super step.
	self position: self position + (self direction * self speed).
	self bounceIfNeeded.! !

OrcaBall subclass: #OrcaBallModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-SynchronizedBallGame'!

!OrcaBallModel methodsFor: 'logic' stamp: 'LT 4/7/2011 12:04:20.642'!
step 

	self position: self position + (self direction * self speed).
	self bounceIfNeeded.! !

OrcaInput subclass: #OrcaSmartSearch
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'LT 3/1/2011 14:49:51.707'!
classNameFor: aMethodReference

	| classname |
	classname := aMethodReference classSymbol asString.
	(aMethodReference classIsMeta) ifTrue: [ classname := classname, ' class' ].
	^ classname! !

!OrcaSmartSearch class methodsFor: 'instance creation' stamp: 'LT 2/24/2011 21:20:33.501'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSmartSearch class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:04'!
requiredClasses
	
	^ { OrcaWindow }! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 10:16'!
search: aString
	
	| searchString |
	searchString := aString trimBoth.
	^ (searchString first isUppercase) 
		ifTrue: [self searchForClass: searchString]
		ifFalse: [self searchForSelector: searchString]! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 14:28'!
searchForClass: aString

	^ Smalltalk allClasses 
			select: [ :each | each name includesSubstring: aString caseSensitive: false]
			thenCollect: [ :each | 
				{#label -> each name.
				#value -> each name.
				#package -> each category. 
				#class -> each name. 
				#selector -> nil.
				#category -> nil.
				#classside -> false} asObject ]! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'lw 3/1/2011 18:54'!
searchForSelector: aString
	^ (SystemNavigation new allImplementorsOf: aString asSymbol) asArray
		collect: [ :each | 
			| className methodName |
			className := self classNameFor: each.
			methodName := (className , '>>' , each methodSymbol asString).
			{#label -> methodName.
			#value -> methodName.
			#package -> (Smalltalk classNamed: each classSymbol) category.
			#class -> each classSymbol.
			#selector -> each methodSymbol.
			#category -> ((Smalltalk classNamed: className) organization categoryOfElement: each methodSymbol).
			#classside -> each classIsMeta} asObject ]! !

!OrcaSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.831'!
browser
	^ browser! !

!OrcaSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.844'!
browser: anObject
	browser := anObject! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'sec 4/27/2011 12:53'!
enableAutocomplete

	| widget |

	self cssId: 'smartSearch'.
	widget := Js @ '#smartSearch'.
	widget autocomplete
		value:
			{
			(#appendTo -> ('#', OrcaWindow defaultCssId)).
			(#select -> [ :event :ui | self handleSelection: ui ]) .
			(#source
				-> [ :request :response | 
					| matches |
					matches := [ :input | OrcaSmartSearch search: input ] onServer value: (request term).
					response value: matches asArray ]).
			(#minLength -> 3).
			(#delay -> 500)} asObject! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 11:55'!
handleSelection: ui

	self browser
		selectPackage: ui item package;
		selectSide: ui item classside;
		selectClass: ui item class.
	(self isSearchForSelector: ui)
		ifFalse: [ 
			(self browser)
				selectCategory: ui item category;
				selectSelector: ui item selector ].! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 12:00'!
isSearchForSelector: ui

	^ ui item selector isNil! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:25'!
onLoad 

	self enableAutocomplete.
	super onLoad.! !

Object subclass: #ChatMessage
	instanceVariableNames: 'author text time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Chat'!

!ChatMessage methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:17'!
author
	^ author! !

!ChatMessage methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:17'!
author: anObject
	author := anObject! !

!ChatMessage methodsFor: 'initialization' stamp: 'hk 5/4/2011 22:09'!
initialize 
	
	super initialize.
	self time: Time now asString.! !

!ChatMessage methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:17'!
text
	^ text! !

!ChatMessage methodsFor: 'accessing' stamp: 'sw 5/4/2011 15:17'!
text: anObject
	text := anObject! !

!ChatMessage methodsFor: 'accessing' stamp: 'hk 5/4/2011 22:08'!
time
	^ time! !

!ChatMessage methodsFor: 'accessing' stamp: 'hk 5/4/2011 22:09'!
time: anObject
	time := anObject! !

Object subclass: #OrcaMonticelloStatistics
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
afternoonCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 12 ]
		and: [ each time hours < 18 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'accessing' stamp: 'ag 4/28/2011 11:17'!
cache
	Cache ifNil: [ Cache := Dictionary new ].
	^ Cache! !

!OrcaMonticelloStatistics class methodsFor: 'accessing' stamp: 'ag 4/28/2011 11:17'!
cache: anObject
	Cache := anObject! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'ag 4/28/2011 11:17'!
cache: data as: aKey

	self cache
		at: aKey
		put: (self latestRevision -> data).! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'ag 4/28/2011 11:17'!
calculateAndCacheFor: aKey

	| data |
	aKey = #commitsByWeek ifTrue: [ data := self commitsByWeek ].
	aKey = #commitsByWeekDay ifTrue: [ data := self commitsByWeekDay ].
	aKey = #commitsByHour ifTrue: [ data := self commitsByHour ].
	self cache: data as: aKey.
	^ data! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
commitsAtHour: anHour

	^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each time hour = anHour ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:19'!
commitsByHour

	| values |
	values := OrderedCollection new.
	
	0 to: 23 do: [ :hour | | amount record |
		amount := (self commitsAtHour: hour) size.
		record := self jsonObjectLabeled: hour withValues: { amount }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'hour' . 'amount'} withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
commitsByTimeSpan: aTimeSpan

	| result date |
	result := OrderedCollection new.
	date := self firstDate - 1 day.
	[ date <= Date today ] whileTrue:
		[ date := date + aTimeSpan.
		result add: (date -> ((self commitsUntil: date) size)) ].
	^ result! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
commitsByWeek

	| values increment sum |
	values := OrderedCollection new.
	sum := 0.
	(self commitsByTimeSpan: 1 week) do: [ :each | | date record |
		date := each key asString.
		increment := each value - sum.
		record := self jsonObjectLabeled: date withValues: { sum . increment }.
		sum := each value.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'previous commits' . 'increment'} withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
commitsByWeekDay

	| values |
	values := OrderedCollection new.
	self dayNames do: [ :each | | daily morning afternoon evening nightly record |
		daily := self commitsOnWeekDay: each.
		morning := (self morningCommitsOf: daily) size.
		afternoon := (self afternoonCommitsOf: daily) size.
		evening := (self eveningCommitsOf: daily) size.
		nightly := (self nightlyCommitsOf: daily) size.
		record := self jsonObjectLabeled: each withValues: { morning . afternoon .evening . nightly }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'morning' . 'afternoon' . 'evening' . 'nightly' } withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
commitsOnWeekDay: aWeekDay

	 ^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each date weekday = aWeekDay ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:19'!
commitsUntil: aDate

	^ self versionInfos select: [ :each | each date <= aDate ]! !

!OrcaMonticelloStatistics class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:17'!
dayNames

	| nonIsoCompliantWeek sunday |
	nonIsoCompliantWeek := Week dayNames.
	sunday := nonIsoCompliantWeek first.
	^ (nonIsoCompliantWeek
		copyWithout: sunday)
		copyWith: sunday! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
eveningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 18 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
extractRevisionFrom: aVersionInfo

	| versionName segments revision |
	versionName := aVersionInfo name.
	segments := versionName subStrings: '.'.
	(segments size < 2) ifTrue: [ ^ nil ].
	revision := segments last trimLeft: [ :char | char isDigit not ].
	^ revision asNumber! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
filterCommits: versionInfos with: aBlock

	^ versionInfos select: aBlock! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
firstDate

	^ (self versionInfos at: 1) date! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
insert: aVersionInfo into: aDictionary

	aDictionary
		at: (self extractRevisionFrom: aVersionInfo)
		put: aVersionInfo.! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'ag 4/28/2011 11:17'!
isCached: aKey

	(self cache includesKey: aKey)
		ifFalse: [ ^ false ]
		ifTrue:
			[ | association |
			association := self cache at: aKey.
			^ association key == self latestRevision ]! !

!OrcaMonticelloStatistics class methodsFor: 'rendering' stamp: 'ag 4/28/2011 11:18'!
jsonDataAt: aKey

	| data |
	(self isCached: aKey)
		ifTrue: [ data := (self cache at: aKey) value ]
		ifFalse: [ data := self calculateAndCacheFor: aKey ].

	^ '(', (Json render: data), ')'
	
! !

!OrcaMonticelloStatistics class methodsFor: 'rendering' stamp: 'ag 4/28/2011 11:18'!
jsonObjectLabeled: aLabel withValues: values

	^ JsonObject new
		at: #label put: aLabel;
		at: #values put: values;
		yourself! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
latestRevision

	^ self extractRevisionFrom: self latestVersionInfo! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
latestVersionInfo

	^ self workingCopy ancestry ancestors first! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
morningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 6 ]
		and: [ each time hours < 12 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
nightlyCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 0 ]
		and: [ each time hours < 6 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'sw 4/28/2011 12:39'!
package

	^ MCPackage allInstances detect: [ :each | each name = self packageName ]
! !

!OrcaMonticelloStatistics class methodsFor: 'configuration' stamp: 'sw 4/28/2011 12:40'!
packageName

	^ 'Orca-Core'! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
versionInfos

	| current result |
	result := Dictionary new.
	current := self latestVersionInfo.
	self insert: current into: result.
	[ current ancestors notEmpty ] whileTrue: [
		current := current ancestors first.
		self insert: current into: result. ].
	^ result! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/28/2011 11:18'!
workingCopy

	^ self package workingCopy
! !

Object subclass: #OrcaSynchronizedBalls
	instanceVariableNames: 'balls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-SynchronizedBallGame'!

OrcaSynchronizedBalls class
	instanceVariableNames: 'uniqueInstance'!

OrcaSynchronizedBalls class
	instanceVariableNames: 'uniqueInstance'!

!OrcaSynchronizedBalls class methodsFor: 'instance creation' stamp: 'LT 5/3/2011 17:11'!
new

	^ self uniqueInstance! !

!OrcaSynchronizedBalls class methodsFor: 'instance creation' stamp: 'LT 5/3/2011 16:41'!
uniqueInstance

	uniqueInstance ifNil: [ uniqueInstance := self basicNew initialize]. 
	^ uniqueInstance ! !

!OrcaSynchronizedBalls methodsFor: 'game' stamp: 'LT 5/3/2011 16:24'!
addBall
	
	self balls add: OrcaBallModel new.! !

!OrcaSynchronizedBalls methodsFor: 'accessing' stamp: 'LT 5/3/2011 16:42'!
balls
	
	^ balls! !

!OrcaSynchronizedBalls methodsFor: 'accessing' stamp: 'LT 5/3/2011 16:41'!
balls: anObject
	
	balls := anObject! !

!OrcaSynchronizedBalls methodsFor: 'initialize-release' stamp: 'LT 5/3/2011 16:42'!
initialize 

	self balls: Set new.! !

OrcaSelectList subclass: #OrcaBrowserPane
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaBrowserPane class methodsFor: 'instance creation' stamp: 'sec 1/25/2011 16:07'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser
	^ browser! !

!OrcaBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser: anObject
	browser := anObject! !

!OrcaBrowserPane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:53'!
initialize
	
	super initialize.
	self
		position: 0 @ 0;
		extent: 200 @ 300.! !

!OrcaBrowserPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:40'!
update
	
	self clear.! !

OrcaBrowserPane subclass: #OrcaClassPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaClassPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser protocolList clear.! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:56'!
selectedClassName

	| className |
	className := self currentSelection.
	(self browser sideSelector currentSelection = 'class') ifTrue: [className := className, ' class'].
	^ className! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 4/5/2011 09:17'!
updateForClass

	self browser protocolList update.
	self browser codeBox displayClassDefinition! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:15'!
updateForPackage: aPackageName
	
	| packageClassNames |
	self browser spinner show.
	self browser saveButton disable.
	self update.
	packageClassNames := [ :name | Smalltalk allClasses 
			select: [ :each | each category asString = name ]
			thenCollect: [ :eachClass | eachClass name asString ] ]
		onServer value: aPackageName.
	packageClassNames do: 
		[ :each | self
			addString: each 
			onClickDo: 
				[ self updateForClass ]].
	self browser spinner hide.! !

OrcaBrowserPane subclass: #OrcaMethodPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaMethodPane methodsFor: 'rendering' stamp: 'LT 1/26/2011 10:54:45.028'!
clear

	super clear.
	self browser codeBox clear.! !

!OrcaMethodPane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:43:30.445'!
updateForClass: aClassName in: aProtocolName

	|selectors|
	self browser spinner show.
	self update.
	self browser saveButton disable.
	selectors := [ :className :category || selectorNames class |
			class := Smalltalk classNamed: className.
			selectorNames := class organization
				listAtCategoryNamed: category.
			selectorNames collect: [ :each | each asString ]
		] onServer value: aClassName value: aProtocolName.
	selectors do: [ :selector |
			self
				addString: selector asString
				onClickDo: [ self browser codeBox updateFor: selector of: aClassName]].
	self browser spinner hide.! !

OrcaBrowserPane subclass: #OrcaPackagePane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaPackagePane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:53'!
clear

	super clear.
	self browser classList clear.! !

!OrcaPackagePane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:27'!
initialize

	super initialize.
	self update.! !

!OrcaPackagePane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:44:24.622'!
update
	
	| allCategoryNames |
	self browser spinner show.
	super update.
	allCategoryNames := [ Smalltalk organization categories
			collect: [ :each | each asString ] ]
		onServer value.
	allCategoryNames do: 
		[ :each | 
			self
				addString: each
				onClickDo: [ self browser classList updateForPackage: each ]].
	self browser spinner hide.			! !

OrcaBrowserPane subclass: #OrcaProtocolPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaProtocolPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser methodList clear.! !

!OrcaProtocolPane methodsFor: 'rendering' stamp: 'sw 3/31/2011 09:02'!
update
	
	| allCategoryNames className |
	self browser spinner show.
	super update.	
	className := self browser classList selectedClassName.
	allCategoryNames := [ :class  |
			(Smalltalk classNamed: class) 
				organization categories 
				collect: [ :each | each asString ] ]
		onServer value: className.
	allCategoryNames do: 
		[ :eachCategory | 
			self
				addString: eachCategory
				onClickDo: [ self browser methodList updateForClass: className in: eachCategory ]].
	self browser spinner hide.! !

OrcaTable subclass: #OrcaTicTacToeGrid
	instanceVariableNames: 'symbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-TicTacToe'!

!OrcaTicTacToeGrid class methodsFor: 'configuration' stamp: 'sw 4/7/2011 14:00'!
numberOfRows

	^ 3! !

!OrcaTicTacToeGrid class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:27'!
requiredClasses
	
	^ { OrcaTableCell. OrcaTableRow. OrcaTicTacToe }! !

!OrcaTicTacToeGrid methodsFor: 'initialization' stamp: 'hk 4/8/2011 13:04'!
addFields

	1 to: (OrcaTicTacToe fieldsPerRow) do: [ :rowIndex | | row |
		row := OrcaTableRow new.
		1 to: (OrcaTicTacToe fieldsPerRow) do: [ :cellIndex | | cell |
			cell := OrcaTableCell new
					onClickDo: [ self markCellInRow: rowIndex andColumn: cellIndex. ].
			row add: cell.
		].
		self add: row.
	].! !

!OrcaTicTacToeGrid methodsFor: 'rendering' stamp: 'sw 4/8/2011 08:15'!
fillWith: anOrderedCollection

	1 to: (OrcaTicTacToe fieldsPerRow) do: [ :rowIndex  | 
		| row |
		row := self children at: rowIndex.
		1 to: (OrcaTicTacToe fieldsPerRow) do: [ :cellIndex  | 
			| cell |
			cell := row children at: cellIndex.
			cell text: anOrderedCollection removeFirst.		
		]
	]! !

!OrcaTicTacToeGrid methodsFor: 'initialization' stamp: 'sw 4/7/2011 17:11'!
initialize 
	
	super initialize.
	self addFields.
	self cssId: 'grid'.
	self symbol: '#'.! !

!OrcaTicTacToeGrid methodsFor: 'playing' stamp: 'hk 4/8/2011 13:06'!
markCellInRow: rowIndex andColumn: columnIndex

	| cellIndex |
	cellIndex := ((OrcaTicTacToe fieldsPerRow * (rowIndex - 1)) + columnIndex).
	[ :position :symbol | OrcaTicTacToe putMySymbol: symbol at: position asNumber ]
		onServer value: cellIndex asString value: self symbol.
	! !

!OrcaTicTacToeGrid methodsFor: 'accessing' stamp: 'sw 4/7/2011 17:11'!
symbol
	^ symbol! !

!OrcaTicTacToeGrid methodsFor: 'accessing' stamp: 'sw 4/7/2011 17:11'!
symbol: anObject
	symbol := anObject! !

OrcaShape subclass: #OrcaBallView
	instanceVariableNames: 'ballModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-SynchronizedBallGame'!

!OrcaBallView methodsFor: 'accessing' stamp: 'LT 4/7/2011 12:05:05.014'!
ballModel
	^ ballModel! !

!OrcaBallView methodsFor: 'accessing' stamp: 'LT 4/7/2011 12:05:26.142'!
ballModel: anObject
	ballModel := anObject! !

!OrcaBallView methodsFor: 'graphics' stamp: 'LT 4/7/2011 12:05:05.024'!
drawOn: aGraphics
	"CTK library: http://canvastoolkit.codeplex.com/"
	
	aGraphics setColor value: self color.
	aGraphics fillCircle
		value: self ballModel position x
		value: self ballModel position y
		value: self ballModel radius.! !

!OrcaBallView methodsFor: 'graphics' stamp: 'LT 4/7/2011 11:59:40.958'!
step
	
	self drawOn: self graphics.! !

OrcaShape subclass: #OrcaWorld
	instanceVariableNames: 'bounds elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

OrcaWorld subclass: #OrcaBallGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OrcaBallGame commentStamp: 'sec 1/4/2011 10:22' prior: 0!
usage:
S2JCodeFactory clearCache.
S2JBouncingBallsApp startWebApp.!

!OrcaBallGame class methodsFor: 'configuration' stamp: 'ag 4/26/2011 17:58'!
isOrcaRootComponent
	
	^ true! !

!OrcaBallGame class methodsFor: 'configuration' stamp: 'ag 4/26/2011 17:52'!
orcaTitle
	
	^ 'Bouncing Balls'! !

!OrcaBallGame class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:07'!
requiredClasses
	
	^ { OrcaBall }! !

!OrcaBallGame class methodsFor: 'configuration' stamp: 'ag 4/26/2011 17:53'!
uniquePath
	
	^ 'balls'! !

!OrcaBallGame methodsFor: 'graphics' stamp: 'ag 4/6/2011 15:52'!
addBall
	
	^ self elements
		add: 
			(OrcaBall new
				canvas: self canvas;
				graphics: self graphics;
				yourself)! !

!OrcaBallGame methodsFor: 'initialization' stamp: 'ag 3/29/2011 14:07'!
initialize
	
	super initialize.
	self addBall.! !

OrcaBallGame subclass: #OrcaSynchronizedBallGame
	instanceVariableNames: 'serverCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-SynchronizedBallGame'!

!OrcaSynchronizedBallGame class methodsFor: 'configuration' stamp: 'ag 4/27/2011 11:04'!
isOrcaRootComponent
	
	^ true! !

!OrcaSynchronizedBallGame class methodsFor: 'configuration' stamp: 'LT 5/2/2011 11:36'!
orcaSessionClass 

	^ OrcaRemoteObjectsSession! !

!OrcaSynchronizedBallGame class methodsFor: 'configuration' stamp: 'ag 4/27/2011 11:03'!
orcaTitle
	
	^ 'Synchronized Balls'! !

!OrcaSynchronizedBallGame class methodsFor: 'configuration' stamp: 'LT 5/3/2011 16:27'!
requiredClasses
	
	^ {OrcaSynchronizedBalls. OrcaSynchronizedBallGame}! !

!OrcaSynchronizedBallGame class methodsFor: 'configuration' stamp: 'ag 4/27/2011 11:03'!
uniquePath
	
	^ 'synchballs'! !

!OrcaSynchronizedBallGame methodsFor: 'graphics' stamp: 'LT 5/3/2011 16:26'!
addBall
	
	self serverCollection addBall! !

!OrcaSynchronizedBallGame methodsFor: 'initialization' stamp: 'LT 5/3/2011 17:04'!
initialize 

	self serverCollection: OrcaSynchronizedBalls newOnServer.
	super initialize.  ! !

!OrcaSynchronizedBallGame methodsFor: 'accessing' stamp: 'LT 5/3/2011 17:03'!
serverCollection

	^ serverCollection! !

!OrcaSynchronizedBallGame methodsFor: 'accessing' stamp: 'LT 5/3/2011 17:03'!
serverCollection: anObject
	serverCollection := anObject! !

!OrcaSynchronizedBallGame methodsFor: 'graphics' stamp: 'LT 5/3/2011 16:23'!
step

	super step.
	self serverCollection balls do: 
		[ :each | 
			OrcaBallView new 
				ballModel: each;
				drawOn: self graphics]! !

!OrcaWorld class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:11'!
requiredClasses
	
	^ { Rectangle }! !

!OrcaWorld class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:09'!
requiredScripts
	
	^ #( 'misc/canvastoolkit.js' )! !

!OrcaWorld class methodsFor: 'configuration' stamp: 'ag 4/28/2011 11:09'!
start
	
	^ self new run! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.324'!
bounds
	^ bounds! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.336'!
bounds: anObject
	bounds := anObject! !

!OrcaWorld methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:29'!
clear
	
	self graphics setColor value: self color.
	self graphics fillRect
			value: self bounds origin x
			value: self bounds origin y
			value: self bounds corner x
			value: self bounds corner y.! !

!OrcaWorld methodsFor: 'initialization' stamp: 'ag 4/28/2011 13:16'!
createCanvas
	
	Js addToBody:
			'<canvas id="ballCanvas" width="400" height="300" style="background-color: #ffffff;  position: relative; border: solid 1px #000000;"></canvas>'.! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.346'!
elements
	^ elements! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.352'!
elements: anObject
	elements := anObject! !

!OrcaWorld methodsFor: 'initialization' stamp: 'ag 4/20/2011 20:15'!
initialize
	
	super initialize.
	self color: '#0000ff'.
	
	self
		createCanvas;
		canvas: (Js Document getElementById value: #ballCanvas);
		elements: OrderedCollection new;
		bounds: (Rectangle origin: (0@0) corner: (self canvas width @ self canvas height));
		graphics: (Js Global ctk Graphics jsNew: self canvas);
		clear.! !

!OrcaWorld methodsFor: 'graphics' stamp: 'LT 5/3/2011 17:04'!
run
	
	self halt.
	Js Global setInterval
		value: [ self step ]
		value: 3.! !

!OrcaWorld methodsFor: 'graphics' stamp: 'ag 1/12/2011 10:55'!
step
	
	self clear.
	self elements do: [ :each | each step].! !

OrcaButtonSet subclass: #OrcaSideSelector
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSideSelector class methodsFor: 'defaults' stamp: 'hk 3/9/2011 14:56'!
classside

	^ 'class'! !

!OrcaSideSelector class methodsFor: 'defaults' stamp: 'LT 3/1/2011 15:02:14.51'!
instanceside

	^ 'instance'! !

!OrcaSideSelector class methodsFor: 'instance creation' stamp: 'sec 1/26/2011 14:33'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser
	^ browser! !

!OrcaSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser: anObject
	browser := anObject! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'hk 3/9/2011 15:01'!
initialize

	super initialize.
	self name: 'side-selector'.
	self addButtonNamed: self class instanceside.
	self addButtonNamed: self class classside.
	self onChange: [ self browser showSide ].! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToClassside 

	self select: self class classside ! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToInstanceside 

	self select: self class instanceside! !
OrcaTicTacToe initialize!
